//+------------------------------------------------------------------+
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_level1  0

//
//
//
//
//

extern string  TimeFrame         = "Current time frame";
extern int     RsxLength         = 14;
extern int     RsxPrice          = PRICE_CLOSE;
extern string  FirstSymbol       = "";
extern string  SecondSymbol      = "GBPUSD";
extern bool    Interpolate       = true;
extern string  UniqueID          = "RsxDifferentPairs";
extern color   FirstSymbolColor  = DeepSkyBlue;
extern color   SecondSymbolColor = PaleVioletRed;

//
//
//
//
//

double buffer1[];
double buffer2[];

//
//
//
//
//

string indicatorScreenName;
string indicatorFileName;
bool   returnBars;
bool   calculateValues;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   if (FirstSymbol == "" ) FirstSymbol = Symbol();
      SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_LINE,EMPTY,EMPTY,FirstSymbolColor);
      SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_LINE,EMPTY,EMPTY,SecondSymbolColor);

      //
      //
      //
      //
      //
      
      indicatorFileName   = WindowExpertName();
      returnBars          = (TimeFrame=="returnBars");
      calculateValues     = (TimeFrame=="calculateValue");
      timeFrame           = stringToTimeFrame(TimeFrame);
      indicatorScreenName = UniqueID+" "+timeFrameToString(timeFrame)+" RSX ("+RsxLength+" ,"+FirstSymbol+","+SecondSymbol+") ";
   IndicatorShortName(indicatorScreenName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i); if (StringSubstr(name, 0, lookForLength) == lookFor) ObjectDelete(name);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double wrkBuffer[][13];

//
//
//
//
//

int start()
{
   int i,r,y,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0] = limit; return(0); }
           
           //
           //
           //
           //
           //
           
           if (calculateValues)
           {
               if (ArrayRange(wrkBuffer,0) != Bars) ArrayResize(wrkBuffer,Bars);
      
               //
               //
               //
               //
               //
                    
               double Kg = (3.0)/(2.0+RsxLength); 
               double Hg = 1.0-Kg;
               for(i=limit, r=Bars-i-1; i>=0; i--, r++)
               {
                  wrkBuffer[r][12] = iMA(NULL,0,1,0,MODE_SMA,RsxPrice,i);
                  if (i==(Bars-1)) { for (int c=0; c<12; c++) wrkBuffer[r][c] = 0; continue; }  

                  //
                  //
                  //
                  //
                  //
      
                  double mom = wrkBuffer[r][12]-wrkBuffer[r-1][12];
                  double moa = MathAbs(mom);
                  for (int k=0; k<3; k++)
                  {
                     int kk = k*2;
                     wrkBuffer[r][kk+0] = Kg*mom                + Hg*wrkBuffer[r-1][kk+0];
                     wrkBuffer[r][kk+1] = Kg*wrkBuffer[r][kk+0] + Hg*wrkBuffer[r-1][kk+1]; mom = 1.5*wrkBuffer[r][kk+0] - 0.5 * wrkBuffer[r][kk+1];
                     wrkBuffer[r][kk+6] = Kg*moa                + Hg*wrkBuffer[r-1][kk+6];
                     wrkBuffer[r][kk+7] = Kg*wrkBuffer[r][kk+6] + Hg*wrkBuffer[r-1][kk+7]; moa = 1.5*wrkBuffer[r][kk+6] - 0.5 * wrkBuffer[r][kk+7];
                  }
                  if (moa != 0)
                       buffer1[i] = MathMax(MathMin((mom/moa+1.0)*50.0,100.00),0.00); 
                  else buffer1[i] = 50.0;
               }
               return(0);
           }            
           
           //
           //
           //
           //
           //
           
           if (FirstSymbol  != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(FirstSymbol ,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
           if (SecondSymbol != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(SecondSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
           showSymbol("1",FirstSymbol ,10,FirstSymbolColor);
           showSymbol("2",SecondSymbol,22,SecondSymbolColor);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      y = iBarShift(FirstSymbol ,timeFrame,Time[i]); buffer1[i] = iCustom(FirstSymbol ,timeFrame,indicatorFileName,"calculateValue",RsxLength,RsxPrice,0,y);
      y = iBarShift(SecondSymbol,timeFrame,Time[i]); buffer2[i] = iCustom(SecondSymbol,timeFrame,indicatorFileName,"calculateValue",RsxLength,RsxPrice,0,y);
   
         if (timeFrame <= Period() || !Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //
      
         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(    k = 1; k < n; k++)
            {
               buffer1[i+k] = buffer1[i] +(buffer1[i+n]-buffer1[i])*k/n;
               buffer2[i+k] = buffer2[i] +(buffer2[i+n]-buffer2[i])*k/n;
            }               
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void showSymbol(string add, string symbol, int ypos, color theColor)
{
   int window = WindowFind(indicatorScreenName);
   string name;
          name = UniqueID+":"+add;
            ObjectCreate(name,OBJ_LABEL,window,Time[0],0);
               ObjectSet(name, OBJPROP_XDISTANCE, 10);
               ObjectSet(name, OBJPROP_YDISTANCE, ypos);
               ObjectSet(name, OBJPROP_COLOR,theColor);
               ObjectSet(name, OBJPROP_CORNER,1);
               ObjectSetText(name,symbol,9,"Arial bold");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

